package org.jeecg.modules.prowork.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.prowork.entity.proWorkMilestone;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.modules.prowork.service.ProWorkMilestoneService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

 /**
 * @Title: Controller
 * @Description: 项目工作--里程碑确认单
 * @author： jeecg-boot
 * @date：   2021-03-03
 * @version： V1.0
 */
@Api("里程碑确认单接口")
@RestController
@RequestMapping("/prowork/proWorkMilestone")
@Slf4j
 class ProWorkMilestoneController {
	@Autowired
	private ProWorkMilestoneService proWorkMilestoneService;


	 @ApiOperation(value = "分页查询接口", notes = "里程碑确认单分页查询")
	 @ApiImplicitParams({
			 @ApiImplicitParam(name="pkOrg", value="组织",required=false, dataType="String"),
			 @ApiImplicitParam(name="type", value="1.开发 2.实施 3.服务",required=true, dataType="String"),
	 })
	@GetMapping(value = "/list")
	public Result<IPage<proWorkMilestone>> queryPageList(@Valid proWorkMilestone proWorkMilestone,
	  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
	  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
	  HttpServletRequest req) {
		Result<IPage<proWorkMilestone>> result = new Result<IPage<proWorkMilestone>>();
		QueryWrapper<proWorkMilestone> queryWrapper = QueryGenerator.initQueryWrapper(proWorkMilestone, req.getParameterMap());
		queryWrapper.orderByDesc("create_time");
		Page<proWorkMilestone> page = new Page<proWorkMilestone>(pageNo, pageSize);
		IPage<proWorkMilestone> pageList = proWorkMilestoneService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}

	 @ApiOperation(value = "新增", notes = "里程碑确认单新增")
	 @ApiImplicitParams({
			 @ApiImplicitParam(name="pkOrg", value="组织",required=false, dataType="String"),
			 @ApiImplicitParam(name="billcode", value="单据编号",required=true, dataType="String"),
			 @ApiImplicitParam(name="type", value="1.开发 2.实施 3.服务",required=true, dataType="String"),
			 @ApiImplicitParam(name="proId", value="项目档案id",required=true, dataType="String"),
			 @ApiImplicitParam(name="proCode", value="项目档案编码",required=true, dataType="String"),
			 @ApiImplicitParam(name="proName", value="项目档案名称",required=true, dataType="String"),
			 @ApiImplicitParam(name="cusId", value="客户档案id",required=true, dataType="String"),
			 @ApiImplicitParam(name="cusCode", value="客户编码",required=true, dataType="String"),
			 @ApiImplicitParam(name="mileId", value="里程碑id",required=true, dataType="String"),
			 @ApiImplicitParam(name="mileName", value="里程碑(计划)",required=true, dataType="String"),
			 @ApiImplicitParam(name="mileId", value="里程碑确认(0,未确认 1，确认)",required=true, dataType="String"),
			 @ApiImplicitParam(name="mileId", value="里程碑id",required=true, dataType="String"),
			 @ApiImplicitParam(name="mileId", value="里程碑id",required=true, dataType="String"),

			 //	@ApiModelProperty("项目档案")
			 //	private Integer cusId;
			 //	@ApiModelProperty("客户编码")
			 //	private String cusCode;
			 //	@ApiModelProperty("里程碑id")
			 //	private String mileId;
			 //	@ApiModelProperty("里程碑(计划)")
			 //	private String mileName;
			 //	@ApiModelProperty("里程碑确认(0,未确认 1，确认)")
			 //	private Integer mileConfirm;
			 //	@ApiModelProperty("确认时间")
			 //	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
			 //    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
			 //	private Date confirmTime;
			 //	@ApiModelProperty("工作内容")
			 //	private String content;
			 //	@ApiModelProperty("工作时长")
			 //	private Double duration;
			 //	@ApiModelProperty("文件id")
			 //	private String updateFileId;
			 //	@ApiModelProperty("填写人(当前用户)")
			 //	private String currentUser;
			 //	@ApiModelProperty("创建时间")
			 //	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
			 //    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
			 //	private Date createTime;
			 //	@ApiModelProperty("创建人")
			 //	private String createBy;
			 //	@ApiModelProperty("修改时间")
			 //	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
			 //    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
			 //	private Date updateTime;
			 //	@ApiModelProperty("修改人")
			 //	private String updateBy;
			 //	@ApiModelProperty("删除状态（0，正常，1已删除）")
			 //	private String delFlag;
			 //	@ApiModelProperty("组织")
			 //	private String pkOrg;
	 })
	@PostMapping(value = "/add")
	public Result<proWorkMilestone> add(@RequestBody proWorkMilestone proWorkMilestone, BindingResult bindingResult) {
		Result<proWorkMilestone> result = new Result<proWorkMilestone>();
		try {
			StringBuilder sb = new StringBuilder();
			if (bindingResult.hasErrors()){
				//记录错误信息
				bindingResult.getAllErrors().stream().forEach(error -> sb.append(error.getDefaultMessage() + "<br/>"));
				result.error500(sb.toString());
				return result;
			}
			proWorkMilestoneService.save(proWorkMilestone);
			result.success("添加成功！");
		} catch (Exception e) {
			e.printStackTrace();
			log.info(e.getMessage());
			result.error500("操作失败");
		}
		return result;
	}
	
	/**
	  *  编辑
	 * @param proWorkMilestone
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<proWorkMilestone> edit(@RequestBody proWorkMilestone proWorkMilestone) {
		Result<proWorkMilestone> result = new Result<proWorkMilestone>();
		proWorkMilestone proWorkMilestoneEntity = proWorkMilestoneService.getById(proWorkMilestone.getId());
		if(proWorkMilestoneEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = proWorkMilestoneService.updateById(proWorkMilestone);
			//TODO 返回false说明什么？
			if(ok) {
				result.success("修改成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<proWorkMilestone> delete(@RequestParam(name="id",required=true) String id) {
		Result<proWorkMilestone> result = new Result<proWorkMilestone>();
		proWorkMilestone proWorkMilestone = proWorkMilestoneService.getById(id);
		if(proWorkMilestone==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = proWorkMilestoneService.removeById(id);
			if(ok) {
				result.success("删除成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<proWorkMilestone> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<proWorkMilestone> result = new Result<proWorkMilestone>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.proWorkMilestoneService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}
	
	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<proWorkMilestone> queryById(@RequestParam(name="id",required=true) String id) {
		Result<proWorkMilestone> result = new Result<proWorkMilestone>();
		proWorkMilestone proWorkMilestone = proWorkMilestoneService.getById(id);
		if(proWorkMilestone==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(proWorkMilestone);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<proWorkMilestone> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              proWorkMilestone proWorkMilestone = JSON.parseObject(deString, proWorkMilestone.class);
              queryWrapper = QueryGenerator.initQueryWrapper(proWorkMilestone, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<proWorkMilestone> pageList = proWorkMilestoneService.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "项目工作--里程碑确认单列表");
      mv.addObject(NormalExcelConstants.CLASS, proWorkMilestone.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("项目工作--里程碑确认单列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<proWorkMilestone> listproWorkMilestones = ExcelImportUtil.importExcel(file.getInputStream(), proWorkMilestone.class, params);
              for (proWorkMilestone proWorkMilestoneExcel : listproWorkMilestones) {
                  proWorkMilestoneService.save(proWorkMilestoneExcel);
              }
              return Result.ok("文件导入成功！数据行数：" + listproWorkMilestones.size());
          } catch (Exception e) {
              log.error(e.getMessage());
              return Result.error("文件导入失败！");
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

}
