package org.jeecg.modules.prowork.entity;

import java.io.Serializable;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotEmpty;

@ApiModel("里程碑确认单")
@Data
@TableName("pro_work_milestone")
public class proWorkMilestone implements Serializable {
	private static final long serialVersionUID = 3883624886849611941L;
	@ApiModelProperty("id")
	@TableId(type = IdType.UUID)
	private String id;
	@ApiModelProperty("单据编号")
	private String billcode;
	@ApiModelProperty("1.开发 2.实施 3.服务")
	@NotEmpty(message = "参数type不能为空")
	private String type;
	@ApiModelProperty("项目档案id")
	private String proId;
	@ApiModelProperty("项目档案编码")
	private String proCode;
	@ApiModelProperty("项目档案名称")
	private String proName;
	@ApiModelProperty("客户档案id")
	private Integer cusId;
	@ApiModelProperty("客户编码")
	private String cusCode;
	@ApiModelProperty("里程碑id")
	private String mileId;
	@ApiModelProperty("里程碑(计划)")
	private String mileName;
	@ApiModelProperty("里程碑确认(0,未确认 1，确认)")
	private Integer mileConfirm;
	@ApiModelProperty("确认时间")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	private Date confirmTime;
	@ApiModelProperty("工作内容")
	private String content;
	@ApiModelProperty("工作时长")
	private Double duration;
	@ApiModelProperty("文件id")
	private String updateFileId;
	@ApiModelProperty("填写人(当前用户)")
	private String currentUser;
	@ApiModelProperty("创建时间")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	private Date createTime;
	@ApiModelProperty("创建人")
	private String createBy;
	@ApiModelProperty("修改时间")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	private Date updateTime;
	@ApiModelProperty("修改人")
	private String updateBy;
	@ApiModelProperty("删除状态（0，正常，1已删除）")
	private String delFlag;
	@ApiModelProperty("组织")
	private String pkOrg;

	public proWorkMilestone() {
	}

	public proWorkMilestone(String id, String billcode, String proId, String proCode, String proName, Integer cusId, String cusCode, String mileId, String mileName, Integer mileConfirm, Date confirmTime, String content, Double duration, String updateFileId, String currentUser, Date createTime, String createBy, Date updateTime, String updateBy, String delFlag, String pkOrg) {
		this.id = id;
		this.billcode = billcode;
		this.type = type;
		this.proId = proId;
		this.proCode = proCode;
		this.proName = proName;
		this.cusId = cusId;
		this.cusCode = cusCode;
		this.mileId = mileId;
		this.mileName = mileName;
		this.mileConfirm = mileConfirm;
		this.confirmTime = confirmTime;
		this.content = content;
		this.duration = duration;
		this.updateFileId = updateFileId;
		this.currentUser = currentUser;
		this.createTime = createTime;
		this.createBy = createBy;
		this.updateTime = updateTime;
		this.updateBy = updateBy;
		this.delFlag = delFlag;
		this.pkOrg = pkOrg;
	}
}
